import { ISchema, SchemaNode, ISchemaNode, SchemaType, IJsonPatch } from "./common";
export declare class Schema {
    types: SchemaType[];
    nodes: SchemaNode[];
    constructor(schema?: ISchema);
    add(type: "types" | "nodes", value: SchemaType | SchemaNode, index?: number): IJsonPatch;
    replace(type: "types" | "nodes", index: number, value: SchemaType | SchemaNode): IJsonPatch;
    remove(type: "types" | "nodes", index: number): IJsonPatch;
    addType(name: string, props: string[]): IJsonPatch;
    addArrayNode(nodeId: number, parentId: number, name: number | string): IJsonPatch;
    addMapNode(nodeId: number, parentId: number, name: number | string, keys?: string[]): IJsonPatch;
    addObjectNode(nodeId: number, type: string, parentId: number, name: number | string): IJsonPatch;
    addNode(nodeId: number, type: number, parentId: number, name: number | string, keys?: string[]): IJsonPatch;
    addMapNodeKey(index: number, key: string): IJsonPatch | undefined;
    deleteNode(nodeId: number, deleteChildren?: boolean): IJsonPatch | undefined;
    getTypeProps(index: number): string[];
    getNodeName(sn: SchemaNode | ISchemaNode): string | number;
    getNodeIndex(parentId: number, name: string): number;
    getNode(nodeId: number): ISchemaNode | undefined;
    getNodePath(sn: SchemaNode | ISchemaNode): string;
    getChildNode(sn: SchemaNode | ISchemaNode | undefined, name: string | number): ISchemaNode | undefined;
    findNode(query: {
        [key: string]: any;
    }): ISchemaNode | undefined;
}
